/*
 * Copyright (c) 1992 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 *
 */

/*** 		$PINGKYDIR 
	Either set the PINGKYDIR variable to point where the config and data
	files should live, or pick a default appropriate for your site.

	We found it useful to make the $PINGKYDIR be a nfs-mountable partition
	so that other machines can run the displays while one or more machines
	can run the collector(s).

	If there is no $PINGKYDIR environmental variable, the following 
	#define tells the rover code where to default $PINGKYDIR.
 ***/
#define DEFAULT_PINGKY_DIR      "./"

/*
 *  The following are relative pathnames to the path above.
 */

#define ROVERD_CYCLE    	"inetroverd.STATUS"
#define PINGD_CYCLE     	"pingd.cycle"
#define NEWROVER_CYCLE  	"NewRover.cycle"
#define PROBLEM_LOG     	"problemlog"
#define HOST_FILE       	"hostfile"
#define PROBLEM_FILE    	"PROBLEM.FILE"
#define FILTER_FILE     	"pingky.filter"
#define PROBLEM_MGR_CONF	"ProblemManager.config"
#define CHECK_FILE		"CHECKING"
#define PINGD_STATUS		"pingd.STATUS"
#define PINGD_PID		"pingd.pid"
#define DNSCACHEFILE		".DNScache"
#define ASCACHEFILE		"as-as3.now"
#define ROVER_LOG		"rover.log"
/*
 *  The following are absolute pathnames.
 */
#define GETNEIGHBORS2		"getneighbors2"
#define NQ_ERRLOG		"/dev/null"
#define BGPKLUDGE		"BGPKLUDGE"
