/*
 * Copyright (c) 1992 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 *
 */

extern int NetQuery();		/* network query */
extern int NetService();	/* get network service index */

char *NetServiceString(); 	/* displays service passed service index */
char *NetStatusString();  	/* displays status passed status string */

/************************************************************************
 *      Network Services that we are interested in trying               *
 ************************************************************************/
#define ERROR  		-1
#define NONE    	 0
#define PING    	 1
#define SGMP    	 2
#define SNMP    	 3
#define TELNET  	 4
#define FTP     	 5
#define SMTP    	 6
#define NAMED   	 7
#define TROUBLE 	 8
#define LOGICALINK 	 9
#define ATPING 		10
#define ATLOOK 		11
#define FINGER 		12
#define DIXIE 		13
#define GOPHER		14
#define GENERIC 	15
#define MAXSERVICES 	15

/************************************************************************
 *      NetQuery and NetService Return Codes                            *
 ************************************************************************/
#define ITERROR 	-1
#define ITWORKS 	 0 
#define ITBROKE 	 1 
#define ITDEAD 		 2
